<?php
/*
original file name   : myroot.lib.php
begin                : September 27 2005
copyright            : (C) 2005 Olivier D. alias ze kat
email                : oliezekat@yahoofr
web					 : www.yahooplus.fr.st

This program is free software; you can redistribute it and/or modify  	
it under the terms of the GNU General Public License as published by  
the Free Software Foundation; either version 2 of the License, or	    	
(at your option) any later version.

AUTHORS:
Olivier D. alias ze kat :	oliezekat@yahoo.fr	since September 27 2005

GLOBAL VARS:
$mYRoot[][]			:	Array (2x) which store settings

FUNCTIONS AVAILABLES:
mYRoot()							: usefull alias of mYR_GetRootPath()
mYRootURL()							: usefull alias of mYR_GetRootURL()
mYR_isChildFolder()					:
mYR_GetRootURL()					: return root URL (checked and) used
mYR_GetRootLevel()					:
mYR_DirLevelToString()				:
mYR_GetRootPath()					: return string with '../' requires to back at root
mYR_Include()						:
mYR_IncludeOnce()					:
*/

// Init some globals vars

$mYRoot['Root']['URL']					= '';
// Examples :
// $mYRoot['Root']['URL']					= 'http://pagesperso.laposte.net/yahooplus/';
// online, for personal account from ISB
// $mYRoot['Root']['URL']					= 'http://olid/yplus/';
// alias from local network (with easyPHP)

$mYRoot['Protocol']['Scheme']			= 'http://';
// set 'https://' for crypted website

// -------------------------------------------------------------------
// Publics functions
// -------------------------------------------------------------------

function mYRoot($rootURL='',$glueChar='/')
	{
	return mYR_GetRootPath($rootURL,$glueChar);
	}
	
function mYRootURL($rootURL='')
	{
	return mYR_GetRootURL($rootURL);
	}
	
// -------------------------------------------------------------------
// Private functions
// -------------------------------------------------------------------
	
function mYR_isChildFolder($parentURL,$childURL)
	{
	if (substr($childURL,0, strlen($parentURL)) != $parentURL)
		{
		return FALSE;
		}
	else
		{
		return TRUE;
		}
	}
	
function mYR_GetRootURL($rootURL='')
	{
	Global $mYRoot;
	
	if ($rootURL == '') $rootURL = $mYRoot['Root']['URL'];
	if ($rootURL == '') $rootURL = $mYRoot['Protocol']['Scheme'].$_SERVER['HTTP_HOST'];
	if (substr($rootURL, -1) == '/') $rootURL = substr($rootURL,0, strlen($rootURL)-1);
	
	$currentURL = $mYRoot['Protocol']['Scheme'].$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
	if (mYR_isChildFolder($rootURL,$currentURL) == FALSE)
		{
		if ($mYRoot['Root']['URL'] != '')
			{
			header('Location: '.$mYRoot['Root']['URL']);
			die('Root URL not found. Redirect to '.$mYRoot['Root']['URL']);
			}
		else
			{
			$parsedCurrentURL = parse_url($currentURL);
			$rootURL = $parsedCurrentURL['scheme'].$parsedCurrentURL['host'];
			}
		}
		
	if ($mYRoot['Root']['URL'] == '') $mYRoot['Root']['URL']=$rootURL;
	
	return $rootURL.'/';
	}

function mYR_GetRootLevel($rootURL='')
	{
	Global $mYRoot;
			
	$rootURL = mYR_GetRootURL($rootURL);
	$currentURL = $mYRoot['Protocol']['Scheme'].$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
	$relCurrentURL = substr($currentURL,strlen($rootURL));
	$pathinfoCurrentURL = pathinfo($relCurrentURL);
	
	if ($pathinfoCurrentURL['dirname'] == '')
		{
		$rootLevel = 0;
		}
	else
		{
		$rootLevel = 0;
		$explodedCurrentDir = explode('/',$pathinfoCurrentURL['dirname']);
		foreach($explodedCurrentDir as $dirName)
			{
			if (($dirName == '.') OR ($dirName == ''))
				{
				
				}
			else if ($dirName == '..')
				{
				$rootLevel--;
				}
			else
				{
				$rootLevel++;
				}
			}
		}
	return $rootLevel;
	}
	
function mYR_DirLevelToString($dirLevel=0,$glueChar='/')
	{
	$dirLevelString = '';
	if ($dirLevel >= 1)
		{
		for ($i = 1; $i <= $dirLevel; $i++)
			{
			$dirLevelString .= '..'.$glueChar;
			}
		}
	return $dirLevelString;
	}
	
function mYR_GetRootPath($rootURL='',$glueChar='/')
	{
	return mYR_DirLevelToString(mYR_GetRootLevel($rootURL),$glueChar);
	}

//Attention: les variables dans l'include ne seront pas globales si vous ne le spcifiez pas
function mYR_Include($fileRelPath,$rootURL='')
	{
	if ($fileRelPath != '')
		{
		if (substr($fileRelPath, 0, 1) == '/') $fileRelPath = substr($fileRelPath,1, strlen($fileRelPath)-1);
		$fileAbsPath = mYR_GetRootPath($rootURL).$fileRelPath;
		include($fileAbsPath);
		}
	}
	
//Attention: les variables dans l'include ne seront pas globales si vous ne le spcifiez pas
function mYR_IncludeOnce($fileRelPath,$rootURL='')
	{
	if ($fileRelPath != '')
		{
		if (substr($fileRelPath, 0, 1) == '/') $fileRelPath = substr($fileRelPath,1, strlen($fileRelPath)-1);
		$fileAbsPath = mYR_GetRootPath($rootURL).$fileRelPath;
		include_once($fileAbsPath);
		}
	}
?>
